﻿using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.IO;
using System.Net;


namespace Snapshot
{

    public class JsonUtils
    {
        public static string buildData(LocalPlayer Me, LinkedList<double[]> pathFull, Dictionary<double, double[]> zones)
        {

            //Logging.Write("sdata start");
            string target = "none";
            int targetlvl = 0;

            if (Me.CurrentTarget != null)
            {
                target = Me.CurrentTarget.Name;
                targetlvl = Me.CurrentTarget.Level;
            }
            //Logging.Write("***********************************************");
            string plr = String.Format(
                " \"Player\" : {{\"Name\" : \"{0}\", \"Level\" : \"{1}\",  \"CurrHealth\" : \"{2}\",  \"TotalHealth\" : \"{3}\", "
               + " \"Target\" : \"{4}\",  \"TargetLvl\" : \"{5}\", \"Location\" :  \"{6}\",  \"Gold\" : \"{7}\",  \"Durability\" : \"{8}\" , "
               + " \"PercentHp\" : \"{9}\" ,  \"Class\" : \"{10}\" ,  \"Deaths\" : \"{11}\" }}"
                    , FixEscapeCharacterSequence(Me.Name[0].ToString()), Me.Level, Me.CurrentHealth, Me.MaxHealth, target, targetlvl,
                    FixEscapeCharacterSequence(Me.ZoneText), Me.Gold, (Me.LowestDurabilityPercent*100), Me.HealthPercent, Me.Class, Styx.CommonBot.GameStats.Deaths);
            //Logging.Write(plr);
            //Logging.Write("***********************************************");
            double[] xy = MapUtils.getXY(Me, zones);
            string coords = String.Format("\"Coords\" : {{ \"zoneId\" : \"{0}\" , \"x\" : \"{1}\" , \"y\" : \"{2}\" }}",
                MapUtils.doubleToString(xy[0]), MapUtils.doubleToString(xy[1]), MapUtils.doubleToString(xy[2])); ;
            //Logging.Write(coords);
            //Logging.Write("***********************************************");
            string questlog = "\"QuestLog\" : [";
            int questcounter = 0;
            foreach (Quest q in Me.QuestLog.GetAllQuests())
            {
                string quest = String.Format(
                    "{{ \"id\" : \"{0}\" , "
                    + " \"title\" : \"{1}\" , "
                    + " \"level\" : \"{2}\" }} ", q.Id, FixEscapeCharacterSequence(q.Name), q.Level);

                questlog = string.Concat(questlog, quest);
                questcounter++;
                if (questcounter < Me.QuestLog.GetAllQuests().Count)
                {
                    questlog = string.Concat(questlog, ", ");
                }
            }
            questlog = string.Concat(questlog, "]");
            //Logging.Write(questlog);
            //Logging.Write("***********************************************");

            String inventory = "\"Inventory\" : [";
            int inventorycounter = 0;
            foreach (WoWItem item in Me.BagItems)
            {
                string quest = String.Format(
                   "{{ \"id\" : \"{0}\" , "
                   + " \"name\" : \"{1}\" , "
                   + " \"quality\": \"{2}\" , "
                   + " \"quantity\" : \"{3}\" }} ", item.Entry, FixEscapeCharacterSequence(item.GetItemName()), item.Quality, item.StackCount);
                inventory = string.Concat(inventory, quest);
                inventorycounter++;
                if (inventorycounter < Me.BagItems.Count)
                {
                    inventory = string.Concat(inventory, ", ");
                }
            }
            inventory = string.Concat(inventory, "]");
            //Logging.Write(inventory);
            //Logging.Write("***********************************************");

            String path = "\"Path\" : [";
            int pathcounter = 0;
            foreach (double[] pathxy in pathFull)
            {
                pathcounter++;
                if (pathxy[0] == Me.ZoneId)
                {
                    string pathpoint = String.Format("{{ \"zoneId\" : \"{0}\" , \"x\" : \"{1}\" , \"y\" : \"{2}\" , \"opacity\" : \"{3}\" }}",
                        MapUtils.doubleToString(pathxy[0]), MapUtils.doubleToString(pathxy[1]), MapUtils.doubleToString(pathxy[2]), pathxy[3]); ;
                    path = string.Concat(path, pathpoint);
                    if (pathcounter < pathFull.Count)
                    {
                        path = string.Concat(path, ", ");
                    }
                }

            }
            path = string.Concat(path, "]");

            string timeStamp = (string.Format("{0:HH:mm:ss tt}", DateTime.Now));
            string time = String.Format(" \"TimeStamp\" : \"{0}\" ", timeStamp);
            string nextRefresh = (string.Format("{0:HH:mm:ss tt}", DateTime.Now.AddMinutes(Snapshot.minutes)));
            string refresh = String.Format(" \"Refresh\" : \"{0}\" ", nextRefresh);

            string sdata = String.Format("{{ {0}, {1}, {2}, {3}, {4}, {5} , {6} }}", plr, coords, questlog, inventory, path, time, refresh);
            //Logging.Write(sdata);

            //Logging.Write(path);   
            //Logging.Write("***********************************************");
            //Logging.Write("sdata done");
            return sdata;

        }
        public static string FixEscapeCharacterSequence(string query)
        {
            query = query.Replace("'", "&#8217;");
            //..Any other replace statements you need
            //....

            return query;
        }

        public static void jsonPut(string sdata, string id)
        {
            HttpWebRequest request = WebRequest.CreateHttp(String.Format("https://api.myjson.com/bins/{0}",id));
            request.Method = "PUT";
            request.AllowWriteStreamBuffering = false;
            request.ContentType = "application/json";
            request.Accept = "Accept=application/json";
            request.SendChunked = false;
            request.ContentLength = sdata.Length;
            using (var writer = new StreamWriter(request.GetRequestStream()))
            {
                writer.Write(sdata);
            }
            var response = request.GetResponse() as HttpWebResponse;
        }
        public static string createJson(string sdata)
        {
            Logging.Write("json");
            HttpWebRequest request = WebRequest.CreateHttp("https://api.myjson.com/bins");
            request.Method = "POST";
            request.AllowWriteStreamBuffering = false;
            request.ContentType = "application/json";
            request.Accept = "Accept=application/json";
            request.SendChunked = false;
            request.ContentLength = sdata.Length;
            using (var writer = new StreamWriter(request.GetRequestStream()))
            {
                writer.Write(sdata);
            }
            var response = request.GetResponse() as HttpWebResponse;
            Stream stream = response.GetResponseStream();
            StreamReader reader = new StreamReader(stream);

            var result = reader.ReadToEnd();
            stream.Dispose();
            reader.Dispose();

            int begin = result.LastIndexOf("/")+1;
            int end = result.LastIndexOf("\"");
            string newId = result.Substring(begin, end-begin);

            return newId;
        }
    }
}
