﻿using Styx.Common;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;

namespace Snapshot
{
    class MapUtils
    {

        public static Dictionary<double, double[]> parseCoords(String zonesFile)
        {
            Dictionary<double, double[]> zones = new Dictionary<double, double[]>();
            char decimalSepparator = '.';
            String[] lines = System.IO.File.ReadAllLines(zonesFile);
            for (int i = 0; i < lines.Length; i++ )
                {
                    
                    String[] line = lines[i].Split(';');

                    String szoneId = line[0];
                    String sy1 = line[1];
                    String sy2 = line[2];
                    String sx1 = line[3];
                    String sx2 = line[4];

                    double zoneId = Double.Parse(szoneId);
                    double y1 = getDbl(sy1);
                    double y2 = getDbl(sy2);
                    double x1 = getDbl(sx1);
                    double x2 = getDbl(sx2);

                    double[] coords = { y1, y2, x1, x2 };

                    zones.Add(zoneId, coords); 
                }
            Logging.Write("Zones Parsing Complete");
            return zones;
        }
        /**
         *   1) Get Y1, Y2, X1, X2 from the list for the ZoneID
         *   2) Calculate X2 - X1 --> Abbreviated with Xdifference
         *   3) Calculate Y2 - Y1 --> Abbreviated with Ydifference
         *   4) Calculate CharacterX - X1 --> Abbreviated with Xspace
         *   5) Calculate CharacterY - Y1 --> Abbreviated with Yspace
         *   6) Calculate Xspace / Xdifference and multiply the outcome by 100. 
         *   7) Calculate Yspace / Ydifference and multiply the outcome by 100. 
         *   8) Because the calculations of 6) and 7) can have a negative outcome, also make sure to use the ABS() function to make it positive
         *   9) Or put everything together: ABS(  (CharacterX-X1)/(X2-X1) * 100 )   and ABS(  (CharacterY-Y1)/(Y2-Y1) * 100 ) 
         */
        public static double[] getCoords(LocalPlayer Me, double Y1, double Y2, double X1, double X2, int patherCounter)
        {
            double xDif = X2 - X1;
            double yDif = Y2 - Y1;
            double charX = Me.X - X1;
            double charY = Me.Y - Y1;
            double x = (charX / xDif) * 100;
            double y = (charY / yDif) * 100;
            //Must swap X and Y
            double[] result = { Me.ZoneId, Math.Round(Math.Abs(y),1), Math.Round(Math.Abs(x),1), patherCounter };

            return result;
        }
        /**
         * Maybe figure out a way to add decimal part, more precision
         */
        public static double getDbl(String s)
        {
            String[] dbl = s.Split('.');
            double d = Double.Parse(dbl[0]);
            if (dbl.Length > 1)
            {
                int decimalLength = dbl[1].Length;
                double decimalpart = Double.Parse(dbl[1]);
                for (int i = 0; i < decimalLength; i++)
                {
                    decimalpart = decimalpart / 10;
                }
                d = d + decimalpart;
            }
            return d;
        }

        public static double[] getXY(LocalPlayer Me, Dictionary<double, double[]> zones)
        {
            
            double key = System.Convert.ToDouble(Me.ZoneId);
            if (zones.ContainsKey(key))
            {
                double[] coords = zones[key];
                double[] xy = MapUtils.getCoords(Me, coords[0], coords[1], coords[2], coords[3], 1);
                return xy;

            }
            else
            {
                Logging.Write("Wow Coords not present");
                double[] xy = {0,0,0};
                return xy;
            }
        }

        public static string doubleToString(double d)
        {
           return d.ToString().Replace(",", ".");
        }

    }
    
}
