﻿//Created By Ahd

using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;




namespace Snapshot
{
   
    public class Snapshot : HBPlugin
    {
        //app stuff
        public override string Name { get { return "Snapshot"; } }
        public override Version Version { get { return new Version(1, 0); } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public override string Author { get { return "Ahd"; } }

        //file system
        public static string _datapath = Path.Combine(Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName), "Plugins\\Snapshot");
        public static string sessionsFile = _datapath + @"\Snapshot.txt";
        public static string zonesFile = _datapath + @"\zones.csv";

        //timers
        public static Stopwatch timer = new Stopwatch();
        public static Stopwatch pather = new Stopwatch();
        public static int minutes = 5;
        public static int timerTimeout = (minutes*60); //5 minutes
        public static int patherTimeout = 20;
        public static int patherCounter = 0;
        public static int patherArraySize = 9;
        

        //lists
        public static Dictionary<double, double[]> zones;
        public static LinkedList<double[]> path = new LinkedList<double[]>();
        //public static List<double[]> pathFull = new List<double[]>();

        //json
        public static string jsonId = null;
        public static Boolean saved = false;

        public override void Initialize()
        {
            zones = MapUtils.parseCoords(zonesFile);
            Logging.Write("Init Snapshot Plugin");
            string sdata = JsonUtils.buildData(Me, path, zones);
            //check if this char already has a json associated
            String[] sessions = System.IO.File.ReadAllLines(sessionsFile);
            foreach (string s in sessions)
            {
                String[] session = s.Split(';');
                if (session[0].Equals(Me.Name))
                {
                    jsonId = session[1];
                    Logging.Write(String.Format("Snapshot save file found -----------------------------  using ID: {0}", jsonId));
                    JsonUtils.jsonPut(sdata, jsonId);
                    saved = true;
                }
            }
            if (!saved)
            {
                jsonId = JsonUtils.createJson(sdata);
                Logging.Write(String.Format("Snapshot ----------------------------- Creating new ID: {0}", jsonId));
                JsonUtils.jsonPut(sdata, jsonId);
                using (System.IO.StreamWriter file = new System.IO.StreamWriter(sessionsFile, true))
                {
                    file.WriteLine(String.Format("{0};{1}", Me.Name, jsonId));
                }
            }
        }
         

        public override void Pulse()
        {
            
            //start timers
            if (!timer.IsRunning)
            {
                timer.Reset();
                timer.Restart();
               

            }
            if (!pather.IsRunning)
            {
                pather.Reset();
                pather.Restart();

            }
            //it's time to refresh data
            if (timer.Elapsed.TotalSeconds > timerTimeout)
            {
                timer.Reset();
                //Logging.Write("Snapshot pulsed");
                //Logging.Write(Styx.CommonBot.GameStats.Deaths + " TOTAL DEATHS");
                //buildData(Me, pathFull);
                string sdata = JsonUtils.buildData(Me, path, zones);
                Logging.Write("********Updated JSON********");
                JsonUtils.jsonPut(sdata,jsonId);
                                
            }
            //20 secs have elapsed
            if (pather.Elapsed.TotalSeconds > patherTimeout)
            {
                pather.Reset();
                patherCounter++;
                //Logging.Write("Pather pulsed");

                double[] coords = zones[Me.ZoneId];
                double[] cPath = MapUtils.getCoords(Me, coords[0], coords[1], coords[2], coords[3], patherCounter);
                path.AddLast(cPath);
               // Logging.Write(path.Count + "is size");
                //still have not reached the limit
                if (patherCounter >= patherArraySize )
                {
                    patherCounter = 0;
                    //pathFull = path;
                   // path = new List<double[]>();
                   //Logging.Write("Added path");
                }
                //exceeded max size
                if (path.Count > patherArraySize)
                {
                   // Logging.Write("must sort path");
                    for (LinkedListNode<double[]> node = path.First; node != path.Last; node = node.Next)
                    {
                                              node.Value = node.Next.Value;
                      // Logging.Write("sorting path" );
                    }
                   // Logging.Write("sorted path");   
                    path.RemoveLast();
                  //  Logging.Write("sorted path");   
                }
            }
        }
    }
 }


